/* TOTEM-v3.1 March 4 2008*/

/*
 * ===========================================================
 * TOTEM : A TOolbox for Traffic Engineering Methods
 * ===========================================================
 *
 * (C) Copyright 2004-2006, by Research Unit in Networking RUN, University of Liege. All Rights Reserved.
 *
 * Project Info:  http://totem.run.montefiore.ulg.ac.be
 *
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License version 2.0 as published by the Free Software Foundation;
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
*/
package be.ac.ulg.montefiore.run.totem.repository.bgpAwareIGPWO.GenericBGPAwareLwo.SimulatedAnnealingConcepts;

import be.ac.ulg.montefiore.run.totem.domain.model.Domain;
import be.ac.ulg.montefiore.run.totem.domain.model.Link;

import java.util.Map;
import java.util.HashMap;

/**
 * <p>Creation date: 11 sept. 2007
 *
 * @author Simon Balon (balon@run.montefiore.ulg.ac.be)
 */

public class LinksWeightSolution {
    public Map<String, Float> linkWeights;

    public LinksWeightSolution(Domain domain) {
        linkWeights = new HashMap<String, Float>();
        for (Link l : domain.getUpLinks()) {
            if (l.getLinkType() == Link.Type.INTRA) {
                linkWeights.put(l.getId(), new Float(l.getMetric()));
            }
        }
    }

    public float getMetric(String linkId) {
        return linkWeights.get(linkId).floatValue();
    }

    public void setMetric(String linkId, float value) {
        linkWeights.put(linkId, value);
    }

    public String toString() {
        String listOfLinkWeights = "";
        for (String linkId : linkWeights.keySet()) {
            listOfLinkWeights += linkId + " : " + linkWeights.get(linkId) + "\n";
        }
        return listOfLinkWeights;
    }
}
