/* TOTEM-v3.1 March 4 2008*/

/*
 * ===========================================================
 * TOTEM : A TOolbox for Traffic Engineering Methods
 * ===========================================================
 *
 * (C) Copyright 2004-2006, by Research Unit in Networking RUN, University of Liege. All Rights Reserved.
 *
 * Project Info:  http://totem.run.montefiore.ulg.ac.be
 *
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License version 2.0 as published by the Free Software Foundation;
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
*/
package be.ac.ulg.montefiore.run.totem.visualtopo.model;

/*
* Changes:
* --------
*
*/

/**
 * Define all the events that a listener will receive. The GUIAdpater implements
 * the GUIListener with empty methods. It can be used to reduce the number of method
 * to implements by subclassing the GUIAdapter and overiding only useful methods.
 *
 * <p>Creation date: 9 d�c. 2005
 *
 * @author Ga�l Monfort (monfort@run.montefiore.ulg.ac.be)
*/

public interface GUIListener {

    /**
     * Notify a change in the loaded domains (new domain loaded, domain removed)
    */
    public void domainChanged();

    /**
     * Notify a change in the started algorithms (algorithm stopped, algorithm started)
     */
    public void algoChanged();

    /**
     * Notify a change in the matrices of domain given by ASID
     * @param ASID
     */
    public void matrixChanged(int ASID);
}
